require "numru/spml"
include NumRu::SPML
include Math

im = 8
jm = 8
km = 2
lm = 2
im2 = 32
jm2 = 32
km2 = 10
lm2 = 10

x0 = 0.0
x1 = PI*2
y0 = 0.0
y1 = PI*2

yx = NArray.float(jm,im)
ee = NArray.float(lm*2+1,km*2+1)
ee[1,1] = -0.25
ee[3,1] = -0.25

im.times{|i|
  jm.times{|j|
    yx[j,i] = sin(2*PI*i/im)*cos(2*PI*j/jm)
  }
}

x = NArray.float(im).indgen/im*(x1-x0)-x0
y = NArray.float(jm).indgen/jm*(y1-y0)-y0


id1 = EE.initial(im, jm, km, lm, x0, x1-x0, y0, y1-y0)
id2 = EE.initial(im2, jm2, km, lm, x0, x1-x0, y0, y1-y0)
id3 = EE.initial(im2, jm2, km2, lm2, x0, x1-x0, y0, y1-y0)

EE.ee_ChangeResolutionDomain(id1)

x2 = EE.x_X
y2 = EE.y_Y

ee2 = EE.ee_yx(yx)
yx2 = EE.yx_ee(ee2)


EE.ee_ChangeResolutionDomain(id2)

yx3 = EE.yx_ee(ee2)
ee3 = NArray.float(lm2*2+1,km2*2+1)

EE.ee_ChangeResolutionDomain(id3)
ee3[lm2-lm..lm2+lm,km2-km..km2+km] = ee2
yx4 = EE.yx_ee(ee3)



enum = 0
enum += (x2-x).abs.gt(1.0e-15).count_true
enum += (y2-y).abs.gt(1.0e-15).count_true
enum += (yx2-yx).abs.gt(1.0e-15).count_true
enum += (ee2-ee).abs.gt(1.0e-15).count_true

enum += (yx3-yx4).abs.gt(1.0e-15).count_true

if enum == 0
  print "no errors\n"
else
  raise "error found"
end
