#include "ruby-spml.h"

#ifdef IFORT
extern double w_interpolate_module_mp_interpolate_array00_w_(double*, double*, double*);
#endif
#ifdef GFORTRAN
extern double __w_interpolate_module_MOD_interpolate_array00_w(double*, double*, double*);
#endif


static VALUE
rbspml_Interpolate_array00_w(int argc, VALUE *argv, VALUE self)
{
  VALUE w_data, alon, alat, out;
  double* cw_data;
  double calon;
  double calat;
  double cout;

  rb_scan_args(argc, argv, "30", &w_data, &alon, &alat);
  w_data = na_cast_object(w_data, NA_DFLOAT);
  cw_data = NA_PTR_TYPE(w_data, double*);
  calon = NUM2DBL(alon);
  calat = NUM2DBL(alat);

#if defined IFORT
  cout = w_interpolate_module_mp_interpolate_array00_w_(cw_data, &calon, &calat);
#elif defined GFORTRAN
  cout = __w_interpolate_module_MOD_interpolate_array00_w(cw_data, &calon, &calat);
#elif defined(FFC32) || defined(FFC64)
  rb_raise(rb_eRuntimeError, "Interpolate_array00_w is not supported for FFC comilar");
#endif

  out = rb_float_new(cout);
  return out;
}


void init_w_interpolate_module(VALUE mSPML)
{
  VALUE mW_INTERPOLATE;

  mW_INTERPOLATE = rb_define_module_under(mSPML, "W_INTERPOLATE");

  rb_define_module_function(mW_INTERPOLATE, "Interpolate_array00_w", rbspml_Interpolate_array00_w, -1);
  rb_define_method(mW_INTERPOLATE, "Interpolate_array00_w", rbspml_Interpolate_array00_w, -1);
}
